﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr197_1
{
    // Структура: 
    struct MyStruct {
        // Ссылка на символьный массив: 
        public char[] name;
        // Целочисленное поле:
        public int code;
        // Конструктор:
        public MyStruct(string t, int n) {
            // Создание на основе текста символьного массива.
            // Ссылка на массив присваивается значением полю: 
            name = t.ToCharArray();
            // Значение целочисленного поля: 
            code = n;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Метод для отображения значений полей экземпляра 
        // структуры, переданного аргументом: 
        static void show(MyStruct A) {
            // Преобразование символьного массива в текст: 
            string txt = new string(A.name);
            // Отображение текста:
            Console.WriteLine("Символьный массив [{0}]", txt);
            // Отображение значения целочисленного поля: 
            Console.WriteLine("Числовое поле {0}", A.code);
        }
        // Метод для присваивания новых значений полям 
        // экземпляров структуры:
        static void maker(MyStruct A, ref MyStruct B, int k, char s){ 
            Console.WriteLine("Bыпoлняeтcя метод maker()"); 
            Console.WriteLine("Пepвый аргумент:");
            // Отображение значений полей экземпляра структуры: 
            show(A);
            Console.WriteLine("Второй аргумент:");
            // Отображение значений полей экземпляра структуры: 
            show(B);
            // Изменение значения элемента в массиве:
            A.name[k] = s;
            B.name[k] = s;
            // Изменение значения текстового поля:
            A.code++;
            B.code++;
            Console.WriteLine();
            Console.WriteLine("Пepвый аргумент:");
            // Отображение значений полей экземпляра структуры: 
            show(A);
            Console.WriteLine("Второй аргумент:");
            // Отображение значений полей экземпляра структуры: 
            show(B);
            Console.WriteLine("Meтод maker() завершен\n");
        }

        // Главный метод: 

        static void Main()
        {
            // Создание экземпляров структуры:
            MyStruct A = new MyStruct("Alpha", 100);
            MyStruct B = new MyStruct("Bravo", 200);
            // Вызов статического метода: 
            maker(A, ref B, 4, 'R');
            Console.WriteLine("После вызова метода maker()");
            Console.WriteLine("Экземпляр A:");
            // Отображение значений полей экземпляра структуры: 
            show(A);
            Console.WriteLine("Экземпляр B:");
            // Отображение значений полей экземпляра структуры: 
            show(B);
            // Задержка:
            Console.ReadLine();
        }
    }
}
